PCLI::Context Class Reference

Context for command line interpreter. More...

`#include <cli.h>`

Inheritance diagram for PCLI::Context:

## Public Member Functions

Construction
| Context (PCLI &cli)
| Construct new command line interpreter context. More...
virtual | ~Context ()
| Destroy command line interpreter context. More...
Overrides from PChannel
virtual PBoolean | Write (const void *buf, PINDEX len)
| Low level write to the channel. More...
Operations
bool | Start ()
| Start a command line interpreter thread. More...
void | Stop ()
| Stop command line interpreter context. More...
virtual void | OnStart ()
| Call back frunction for when context is started. More...
virtual void | OnStop ()
| Callback for when context is stopping. More...
virtual bool | WritePrompt ()
| Write prompt (depending on state) to channel. More...
virtual bool | ReadAndProcessInput ()
| Read a character from the attached channel an process. More...
virtual bool | ProcessInput (int ch)
| Process a character read from the channel. More...
virtual bool | ProcessInput (const PString &line)
virtual void | OnCompletedLine ()
| Call back for a command line was completed and ENTER pressed. More...
Member access
PCLI & | GetCLI () const
| Get the CLI. More...
bool | IsProcessingCommand () const
| Indicate is currently processing a command. More...
Public Member Functions inherited from PIndirectChannel
| PIndirectChannel ()
| Create a new indirect channel without any channels to redirect to. More...
| ~PIndirectChannel ()
| Close the indirect channel, deleting read/write channels if desired. More...
Comparison | Compare (const PObject &obj) const
| Determine if the two objects refer to the same indirect channel. More...
virtual PString | GetName () const
| Get the name of the channel. More...
virtual PBoolean | Close ()
| Close the channel. More...
virtual PBoolean | IsOpen () const
| Determine if the channel is currently open and read and write operations can be executed on it. More...
virtual PBoolean | Read (void *buf, PINDEX len)
| Low level read from the channel. More...
virtual PBoolean | Shutdown (ShutdownValue option)
| Close one or both of the data streams associated with a channel. More...
virtual bool | SetLocalEcho (bool localEcho)
| Set local echo mode. More...
virtual PChannel * | GetBaseReadChannel () const
| This function returns the eventual base channel for reading of a series of indirect channels provided by descendents of `PIndirectChannel`. More...
virtual PChannel * | GetBaseWriteChannel () const
| This function returns the eventual base channel for writing of a series of indirect channels provided by descendents of `PIndirectChannel`. More...
virtual PString | GetErrorText (ErrorGroup group=NumErrorGroups) const
| Get error message description. More...
PBoolean | Open (PChannel &channel)
| Set the channel for both read and write operations. More...
PBoolean | Open (PChannel *channel, PBoolean autoDelete=true)
| Set the channel for both read and write operations. More...
PBoolean | Open (PChannel *readChannel, PChannel *writeChannel, PBoolean autoDeleteRead=true, PBoolean autoDeleteWrite=true)
| Set the channel for both read and write operations. More...
PChannel * | GetReadChannel () const
| Get the channel used for read operations. More...
bool | SetReadChannel (PChannel *channel, bool autoDelete=true, bool closeExisting=false)
| Set the channel for read operations. More...
PChannel * | GetWriteChannel () const
| Get the channel used for write operations. More...
PBoolean | SetWriteChannel (PChannel *channel, bool autoDelete=true, bool closeExisting=false)
| Set the channel for read operations. More...
Public Member Functions inherited from PChannel
PBoolean | SetErrorValues (Errors errorCode, int osError, ErrorGroup group=LastGeneralError)
| Set error values to those specified. More...
| PChannel ()
| Create the channel. More...
| ~PChannel ()
| Close down the channel. More...
virtual PINDEX | HashFunction () const
| Calculate a hash value for use in sets and dictionaries. More...
int | GetHandle () const
| Get the integer operating system handle for the channel. More...
void | SetReadTimeout (const PTimeInterval &time)
| Set the timeout for read operations. More...
PTimeInterval | GetReadTimeout () const
| Get the timeout for read operations. More...
virtual PINDEX | GetLastReadCount () const
| Get the number of bytes read by the last Read() call. More...
virtual int | ReadChar ()
| Read a single 8 bit byte from the channel. More...
PBoolean | ReadBlock (void *buf, PINDEX len)
| Read len bytes into the buffer from the channel. More...
PString | ReadString (PINDEX len)
| Read `len` character into a string from the channel. More...
virtual PBoolean | ReadAsync (void *buf, PINDEX len)
| Begin an asynchronous read from channel. More...
virtual void | OnReadComplete (void *buf, PINDEX len)
| User callback function for when a `ReadAsync()` call has completed or timed out. More...
void | SetWriteTimeout (const PTimeInterval &time)
| Set the timeout for write operations to complete. More...
PTimeInterval | GetWriteTimeout () const
| Get the timeout for write operations to complete. More...
virtual PBoolean | Write (const void *buf, PINDEX len, const void *mark)
| Low level write to the channel with marker. More...
virtual PINDEX | GetLastWriteCount () const
| Get the number of bytes written by the last Write() call. More...
PBoolean | WriteChar (int c)
| Write a single character to the channel. More...
PBoolean | WriteString (const PString &str)
| Write a string to the channel. More...
virtual PBoolean | WriteAsync (const void *buf, PINDEX len)
| Begin an asynchronous write from channel. More...
virtual void | OnWriteComplete (const void *buf, PINDEX len)
| User callback function for when a WriteAsync() call has completed or timed out. More...
virtual bool | FlowControl (const void *flowData)
| Flow Control information Pass data to the channel for flowControl determination. More...
PBoolean | SetBufferSize (PINDEX newSize)
| Set the iostream buffer size for reads and writes. More...
PBoolean | SendCommandString (const PString &command)
| Send a command meta-string. More...
void | AbortCommandString ()
| Abort a command string that is in progress. More...
Errors | GetErrorCode (ErrorGroup group=NumErrorGroups) const
| Get normalised error code. More...
int | GetErrorNumber (ErrorGroup group=NumErrorGroups) const
| Get OS errro code. More...
virtual PBoolean | Read (const VectorOfSlice &slices)
| Low level scattered read from the channel. More...
virtual PBoolean | Write (const VectorOfSlice &slices)
| Low level scattered write to the channel. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Types

enum | State { e_Username, e_Password, e_CommandEntry, e_ProcessingCommand }

## Protected Member Functions

| PDECLARE_NOTIFIER (PThread, Context, ThreadMain)
Protected Member Functions inherited from PIndirectChannel
virtual PBoolean | OnOpen ()
| This callback is executed when the Open() function is called with open channels. More...
Protected Member Functions inherited from PChannel
| PChannel (const PChannel &)
PChannel & | operator= (const PChannel &)
virtual PBoolean | ConvertOSError (int libcReturnValue, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
int | ReadCharWithTimeout (PTimeInterval &timeout)
| Read a character with specified timeout. More...
PBoolean | ReceiveCommandString (int nextChar, const PString &reply, PINDEX &pos, PINDEX start)
PBoolean | PXSetIOBlock (PXBlockType type, const PTimeInterval &timeout)
int | PXClose ()
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes

PCLI & | m_cli
PString | m_commandLine
bool | m_ignoreNextEOL
PStringList | m_commandHistory
PThread * | m_thread
enum PCLI::Context::State | m_state
PString | m_enteredUsername
Protected Attributes inherited from PIndirectChannel
PChannel * | readChannel
| Channel for read operations. More...
PBoolean | readAutoDelete
| Automatically delete read channel on destruction. More...
PChannel * | writeChannel
| Channel for write operations. More...
PBoolean | writeAutoDelete
| Automatically delete write channel on destruction. More...
PReadWriteMutex | channelPointerMutex
| Race condition prevention on closing channel. More...
Protected Attributes inherited from PChannel
int | os_handle
| The operating system file handle return by standard open() function. More...
Errors | lastErrorCode [NumErrorGroups+1]
| The platform independant error code. More...
int | lastErrorNumber [NumErrorGroups+1]
| The operating system error number (eg as returned by errno). More...
PINDEX | lastReadCount
| Number of byte last read by the Read() function. More...
PINDEX | lastWriteCount
| Number of byte last written by the Write() function. More...
PTimeInterval | readTimeout
| Timeout for read operations. More...
PTimeInterval | writeTimeout
| Timeout for write operations. More...
PString | channelName
PMutex | px_threadMutex
PXBlockType | px_lastBlockType
PThread * | px_readThread
PThread * | px_writeThread
PMutex | px_writeMutex
PThread * | px_selectThread [3]
PMutex | px_selectMutex [3]

## Additional Inherited Members

Public Types inherited from PChannel
enum | PXBlockType { PXReadBlock, PXWriteBlock, PXAcceptBlock, PXConnectBlock }
enum | ShutdownValue { ShutdownRead = 0, ShutdownWrite = 1, ShutdownReadAndWrite = 2 }
enum | Errors { NoError, NotFound, FileExists, DiskFull, AccessDenied, DeviceInUse, BadParameter, NoMemory, NotOpen, Timeout, Interrupted, BufferTooSmall, Miscellaneous, ProtocolFailure, NumNormalisedErrors }
| Normalised error codes. More...
enum | ErrorGroup { LastReadError, LastWriteError, LastGeneralError, NumErrorGroups }
| Error groups. More...
typedef std::vector< Slice > | VectorOfSlice
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PChannel
static PBoolean | ConvertOSError (int libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...

## Detailed Description

Context for command line interpreter.

## Member Enumeration Documentation

enum PCLI::Context::State

protected

Enumerator
e_Username |
e_Password |
e_CommandEntry |
e_ProcessingCommand |

## Constructor & Destructor Documentation

PCLI::Context::Context | ( | PCLI & | cli | ) |

Construct new command line interpreter context.

virtual PCLI::Context::~Context | ( |  | ) |

virtual

Destroy command line interpreter context.

This will close and wait for threads to exit.

## Member Function Documentation

PCLI& PCLI::Context::GetCLI | ( |  | ) | const

inline

Get the CLI.

References m_cli.

bool PCLI::Context::IsProcessingCommand | ( |  | ) | const

inline

Indicate is currently processing a command.

References e_ProcessingCommand, and m_state.

virtual void PCLI::Context::OnCompletedLine | ( |  | ) |

virtual

Call back for a command line was completed and ENTER pressed.

The default behaviour processes the line into a PArgList and deals with the command history and help.

Control is then passed on to PCLI::OnReceivedLine().

virtual void PCLI::Context::OnStart | ( |  | ) |

virtual

Call back frunction for when context is started.

This is usually called from within a background thread.

The default behaviour displays the prompt.

virtual void PCLI::Context::OnStop | ( |  | ) |

virtual

Callback for when context is stopping.

This is usually called from within a background thread.

The default behaviour does nothing.

PCLI::Context::PDECLARE_NOTIFIER | ( | PThread | ,
|  | Context | ,
|  | ThreadMain |
| ) |  |

protected

virtual bool PCLI::Context::ProcessInput | ( | int | ch | ) |

virtual

Process a character read from the channel.

Returns false if have error and processing is to cease.

virtual bool PCLI::Context::ProcessInput | ( | const PString & | line | ) |

virtual

virtual bool PCLI::Context::ReadAndProcessInput | ( |  | ) |

virtual

Read a character from the attached channel an process.

If the character was successfully read then ProcessInput() is called.

bool PCLI::Context::Start | ( |  | ) |

Start a command line interpreter thread.

void PCLI::Context::Stop | ( |  | ) |

Stop command line interpreter context.

This will close the channel and wait for threads to exit.

virtual PBoolean PCLI::Context::Write | ( | const void * | buf,
|  | PINDEX | len
| ) |  |

virtual

Low level write to the channel.

This function will block until the requested number of characters are written or the write timeout is reached. The GetLastWriteCount() function returns the actual number of bytes written.

This translate new line character ('
') to be the text string in PCLI::m_newLine.

The GetErrorCode() function should be consulted after Write() returns false to determine what caused the failure.

Returns
  true if at least len bytes were written to the channel.

Parameters

  buf | Pointer to a block of memory to write.
  len | Number of bytes to write.

Reimplemented from PIndirectChannel.

virtual bool PCLI::Context::WritePrompt | ( |  | ) |

virtual

Write prompt (depending on state) to channel.

## Member Data Documentation

PCLI& PCLI::Context::m_cli

protected

Referenced by GetCLI().

PStringList PCLI::Context::m_commandHistory

protected

PString PCLI::Context::m_commandLine

protected

PString PCLI::Context::m_enteredUsername

protected

bool PCLI::Context::m_ignoreNextEOL

protected

enum PCLI::Context::State PCLI::Context::m_state

protected

Referenced by IsProcessingCommand().

PThread* PCLI::Context::m_thread

protected

The documentation for this class was generated from the following file:

- cli.h